script_name('Lesorub-Helper')

local imgui = require 'mimgui'
local encoding = require 'encoding'
local hotkey = require 'mimgui_hotkeys'
local inicfg = require 'inicfg'
local sampev = require 'lib.samp.events'

encoding.default = 'CP1251'
local u8 = encoding.UTF8
local new = imgui.new

local cfg = inicfg.load({ config = { bind = '[32]' } }, 'LesorubHelper.ini')
inicfg.save(cfg, 'LesorubHelper.ini')

local Window, collision, posadka, prokachka, spilivanie, zdorove = new.bool(), new.bool(), new.bool(), new.bool(), new.bool(), new.bool()

local checkboxData = {
    { u8'  ', u8'       \n       .', collision },
    { u8' ', u8'     ,   \n     .', posadka },
    { u8' ', u8'   H    \n ,   .', prokachka },
    { u8' ', u8'         ,\n   .', spilivanie }
}

local exampleHotKey = nil

if type(cfg.config.bind) ~= 'string' or cfg.config.bind == '' then
    cfg.config.bind = '[]'
end

imgui.OnFrame(function() return Window[0] end, function()
    local sw, sh = getScreenResolution()
    imgui.SetNextWindowPos(imgui.ImVec2(sw / 2.5, sh / 2), imgui.Cond.FirstUseEver)
    imgui.Begin(u8'Lesorub-Helper', Window, imgui.WindowFlags.AlwaysAutoResize + imgui.WindowFlags.NoScrollbar + imgui.WindowFlags.NoCollapse)

    for i, checkbox in ipairs(checkboxData) do
        imgui.Checkbox(checkbox[1], checkbox[3])
        imgui.SameLine()

        if i == 2 and exampleHotKey and exampleHotKey:ShowHotKey() then
            cfg.config.bind = encodeJson(exampleHotKey:GetHotKey())
            inicfg.save(cfg, 'LesorubHelper.ini')
        end
        
        imgui.SameLine()
        imgui.Text('(?)')
        if imgui.IsItemHovered() then
            imgui.BeginTooltip()
            imgui.Text(checkbox[2])
            imgui.EndTooltip()
        end
    end

    imgui.End()
end)


function main()
    while not isSampAvailable() do wait(100) end
    lua_thread.create(Collision)
    lua_thread.create(posadkaq)
    lua_thread.create(spilivanieq)
    sampAddChatMessage("{FFFFFF}[{00FF00}Lesorub-Helper{FFFFFF}]:  {DC143C}/les {FFFFFF} {DC143C}F9", -1)
    sampRegisterChatCommand('les', function() Window[0] = not Window[0] end)

    if type(cfg.config.bind) ~= 'string' or cfg.config.bind == '' then
        cfg.config.bind = '[]'
    end

    exampleHotKey = hotkey.RegisterHotKey('random hotkey 1', false, decodeJson(cfg.config.bind), function() end)
    
    hotkey.Text.NoKey = u8''
    hotkey.Text.WaitForKey = u8' '

    while true do
        wait(0)
        if wasKeyPressed(0x78) and not sampIsCursorActive() then
            Window[0] = not Window[0]
        end
    end
end

function Collision()
    while true do
        wait(10)
        if collision[0] == true then
        for id = 0, 1000 do
            local handle = sampGetObjectHandleBySampId(id)
            if doesObjectExist(handle) and tostring(getObjectModel(handle)) then
                setObjectCollision(handle, false)
                end
            end
        end
        if collision[0] == false then
            for id = 0, 1000 do
                local handle = sampGetObjectHandleBySampId(id)
                if doesObjectExist(handle) and tostring(getObjectModel(handle)) then
                    setObjectCollision(handle, true)
                    
                    end
                end
            end
    end
end

function posadkaq()
    while true do 
        wait(0)
        if posadka[0] and wasKeyPressed(table.concat(exampleHotKey:GetHotKey())) then
            sampSendChat("/seat")
        end
    end
end

function sampev.onShowDialog(dialogId, style, title, button1, button2, text)
    if prokachka[0] then
        if text:match('{FFFFFF}  : {52AB4A}') then 
            sampAddChatMessage('{00FF00} ', -1)
            sampSendDialogResponse(dialogId, 1, 1, nil)
            return false
        end
        
        local min, sec = text:match('FFFFFF}  : {52AB4A}(%d+):(%d+)')
        if min and sec then 
            sampAddChatMessage('{00FF00} '..min..':'..sec, -1)
            sampSendDialogResponse(dialogId, 1, 1, nil)
            return false
        end
    end
end

function spilivanieq()
    while true do
        wait(0)     
        if spilivanie[0] then
            if isKeyDown(0x02) then
                setVirtualKeyDown(0x01, true)
                wait(10)
                setVirtualKeyDown(0x01, false)
                freezeCharPosition(PLAYER_PED, true)
            else
                freezeCharPosition(PLAYER_PED, false)
            end
        end
    end
end


